
//Source for a igs_reg test program capable to change all igs vga registers
// in real time...
//Woody, April 1998

#define REGE4A0 (0xE4A0 - 0xE430)/4
#define REGE4A4 (0xE4A4 - 0xE430)/4

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/errno.h>
#include <fcntl.h>
#include "igsvga.h"


unsigned short data[] = {
	     0xE430, 0x0000,
	     0xE434, 0x0000,
	     0xE438, 0x3000,
	     0xE43C, 0x020C,
	     0xE440, 0x0029,
	     0xE444, 0x020C,
	     0xE448, 0x0029,
	     0xE44C, 0x7038,
	     0xE450, 0x7878,
	     0xE454, 0x8009,
	     0xE458, 0xDE00,
	     0xE45C, 0x0000,
	     0xE460, 0x003A,
	     0xE464, 0x0000,
	     0xE468, 0x000C,
	     0xE46C, 0x001B,
	     0xE470, 0x0041,
	     0xE474, 0x0061,
	     0xE478, 0x030C,
	     0xE47C, 0x0076,
	     0xE480, 0x020A,
	     0xE484, 0x0011,
	     0xE488, 0x020A,
	     0xE48C, 0x0011,
	     0xE490, 0x0005,
	     0xE494, 0x000B,
	     0xE498, 0x0005,
	     0xE49C, 0x000B,
	     0xE4A0, 0x2D04,
	     0xE4A4, 0x48CC,
	     0xE4A8, 0x0052,
	     0xE4AC, 0x1020,
	     0xE4B0, 0x0000,
	     0xE4B4, 0x0000,
	     0xE4B8, 0x003B,
	     0xE4BC, 0x0001,
	     0xE4C0, 0x02AA,
	     0xE4C4, 0x0001,
	     0xE4C8, 0x8700,
	     0xE4CC, 0x8787,
	     0xE4D0, 0x8787,
	     0xE4D4, 0x8787,
	     0xE4D8, 0x8787,
	     0xE4DC, 0x8787,
	     0xE4E0, 0x8787,
	     0xE4E4, 0x8787,
	     0xE4E8, 0x0000,
	     0xE4EC, 0x0000,
	     0xE4F0, 0x0000,
	     0xE4F4, 0x0000,
	     0xE4F8, 0x0000,
	     0xE4FC, 0x0000,
	     0xE500, 0x0000,
	     0xE504, 0x0000,
	     0xE508, 0x0000,
	     0xE50C, 0x0000,
	     0xE510, 0x0000,
	     0xE514, 0x0000,
	     0xE518, 0x0000,
	     0xE51C, 0x0000,
	     0xE520, 0x0000,
	     0xE524, 0x0001,
	     0xE528, 0x000E,
	     0xE52C, 0x000D
	   };



main(int argc, char *argv[])
{
unsigned int regno, val, i;

int igsvga_fd=-1;
unsigned supported;
int source;

/*
struct
{
char	grf_reg[256];
char	atr_reg[20];
char	crt_reg[25];
char	seq_reg[5];
char	misc_reg;
}igs;
*/

IGSREGS	igs;

char szgrf[] = "Grf";
char szatr[] = "Atr";
char szcrt[] = "Crt";
char szseq[] = "Seq";
char szmisc[]= "Misc";
char szTV[]= "TV";
char szUnknown[] = "???";

char	c;
char*	szReg;

    igsvga_fd=open("/dev/igsvga",O_RDWR);
    if(igsvga_fd<0){
      perror("igs_reg: igsvga not found!");
      exit(-1);
    }

    if (source < 0)
        printf("igsreg: IGS register dump returned error 0x%X!\n", source);   


    source = (int)&igs;
    source = ioctl(igsvga_fd,IGSVGA_READ,&source);

    for(i = 0; i < sizeof(data) / 4; i+=2)
    {
	igs.tv_reg[(data[i] - 0xe430)/4] = data[i+1];
	
    }
    source = (int)&igs;
    source = ioctl(igsvga_fd,IGSVGA_WRITE,&source);

    close(igsvga_fd);

}
