
//Source for a igs_reg test program capable to change all igs vga registers
// in real time...
//Woody, April 1998

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/errno.h>
#include <fcntl.h>
#include "igsvga.h"



main(int argc, char *argv[])
{
unsigned int regno, val, i;

int igsvga_fd=-1;
unsigned supported;
int source;

/*
struct
{
char	grf_reg[256];
char	atr_reg[20];
char	crt_reg[25];
char	seq_reg[5];
char	misc_reg;
}igs;
*/

IGSREGS	igs;

char szgrf[] = "Grf";
char szatr[] = "Atr";
char szcrt[] = "Crt";
char szseq[] = "Seq";
char szmisc[]= "Misc";
char szTV[]= "TV";
char szpal[]= "Pal";
char szUnknown[] = "???";

char	c;
char*	szReg;

    igsvga_fd=open("/dev/igsvga",O_RDWR);
    if(igsvga_fd<0){
      perror("igs_reg: igsvga not found!");
      exit(-1);
    }

    source = (int)&igs;
    source = ioctl(igsvga_fd,IGSVGA_READ,&source);

    if (source < 0)
        printf("igsreg: IGS register dump returned error 0x%X!\n", source);   

    if (argc == 1)
    {
	i=0;
	while(i<256)
	{
		printf("GRF[%02X] %02X %02X %02X %02X.%02X %02X %02X %02X - %02X %02X %02X %02X.%02X %02X %02X %02X\n",
		i,
		igs.grf_reg[i+0],
		igs.grf_reg[i+1],
		igs.grf_reg[i+2],
		igs.grf_reg[i+3],
		igs.grf_reg[i+4],
		igs.grf_reg[i+5],
		igs.grf_reg[i+6],
		igs.grf_reg[i+7],
		igs.grf_reg[i+8],
		igs.grf_reg[i+9],
		igs.grf_reg[i+10],
		igs.grf_reg[i+11],
		igs.grf_reg[i+12],
		igs.grf_reg[i+13],
		igs.grf_reg[i+14],
		igs.grf_reg[i+15]
		);
	i += 16;
	}

	i=0;
	printf("\nATR[%02X] %02X %02X %02X %02X.%02X %02X %02X %02X - %02X %02X %02X %02X.%02X %02X %02X %02X\n",
	i,
	igs.atr_reg[i+0],
	igs.atr_reg[i+1],
	igs.atr_reg[i+2],
	igs.atr_reg[i+3],
	igs.atr_reg[i+4],
	igs.atr_reg[i+5],
	igs.atr_reg[i+6],
	igs.atr_reg[i+7],
	igs.atr_reg[i+8],
	igs.atr_reg[i+9],
	igs.atr_reg[i+10],
	igs.atr_reg[i+11],
	igs.atr_reg[i+12],
	igs.atr_reg[i+13],
	igs.atr_reg[i+14],
	igs.atr_reg[i+15]
	);

	i += 16;
	printf("ATR[%02X] %02X %02X %02X %02X\n",
	i,
	igs.atr_reg[i+0],
	igs.atr_reg[i+1],
	igs.atr_reg[i+2],
	igs.atr_reg[i+3]
	);

	i=0;
	printf("\nCRT[%02X] %02X %02X %02X %02X.%02X %02X %02X %02X - %02X %02X %02X %02X.%02X %02X %02X %02X\n",
	i,
	igs.crt_reg[i+0],
	igs.crt_reg[i+1],
	igs.crt_reg[i+2],
	igs.crt_reg[i+3],
	igs.crt_reg[i+4],
	igs.crt_reg[i+5],
	igs.crt_reg[i+6],
	igs.crt_reg[i+7],
	igs.crt_reg[i+8],
	igs.crt_reg[i+9],
	igs.crt_reg[i+10],
	igs.crt_reg[i+11],
	igs.crt_reg[i+12],
	igs.crt_reg[i+13],
	igs.crt_reg[i+14],
	igs.crt_reg[i+15]
	);

	i += 16;
	printf("CRT[%02X] %02X %02X %02X %02X.%02X %02X %02X %02X - %02X\n",
	i,
	igs.crt_reg[i+0],
	igs.crt_reg[i+1],
	igs.crt_reg[i+2],
	igs.crt_reg[i+3],
	igs.crt_reg[i+4],
	igs.crt_reg[i+5],
	igs.crt_reg[i+6],
	igs.crt_reg[i+7],
	igs.crt_reg[i+8]
	);

	i=01;
	{
		printf("\nSEQ[%02X] %02X %02X %02X %02X\n",
		i,
		igs.seq_reg[i+0],
		igs.seq_reg[i+1],
		igs.seq_reg[i+2],
		igs.seq_reg[i+3]
		);
	}

	printf("\nMiscOutReg  0x%02X.\n",igs.misc_reg);
	printf("\nPalOutReg  0x%02X.\n\n",igs.pal_reg);

#if 1
	i=0;
	while(i<64)
	{
		printf("TV[%04X]%04X %04X %04X %04X.%04X %04X %04X %04X\n",
		0xE430+(i<<2),
		igs.tv_reg[i+0],
		igs.tv_reg[i+1],
		igs.tv_reg[i+2],
		igs.tv_reg[i+3],
		igs.tv_reg[i+4],
		igs.tv_reg[i+5],
		igs.tv_reg[i+6],
		igs.tv_reg[i+7]
		);
	i += 8;
	}
#endif	
    }

//	else if ((argc-1)%3 == 3)
	else if (argc > 2)
	{
		while (argc > 2)
		{
			szReg = szUnknown;

			sscanf(argv[1], "%c", &c);

//			regno = atoi(argv[2]);
			sscanf(argv[2], "%i", &regno);
			sscanf(argv[3], "%i", &val);

			c = tolower(c);

			if (c == 'g')
			{
			    if (regno < 256)
				{
				igs.grf_reg[regno]=val;
				szReg = szgrf;
				}
			}
			else if (c == 'a')
			{
			    if (regno < 20)
				{
				igs.atr_reg[regno]=val;
				szReg = szatr;
				}
			}
			else if (c == 'c')
			{
			    if (regno < 25)
				{
				igs.crt_reg[regno]=val;
				szReg = szcrt;
				}
			}
			else if (c == 'm')
			{
				igs.misc_reg=val;
				szReg = szmisc;
			}
			else if (c == 's')
			{
			    if (regno < 5)
				{
				igs.seq_reg[regno]=val;
				szReg = szseq;
				}
			}
			else if (c == 't')
			{
				unsigned int tv_regno = (regno - 0xE430) / 4;
				if((tv_regno >= 0) && (tv_regno <= 64))
				{
					igs.tv_reg[tv_regno] = val;
					szReg = szTV;
				}
				else
				{
					printf("Port out of range\n");
					exit(1);
				}
			}
			else if (c == 'p')
			{
				igs.pal_reg=val;
				szReg = szpal;
			}

			printf("%s register %02X <- %02X\n", szReg, regno, val);
			argc -= 3;
			argv += 3;
		}

	    source = (int)&igs;
	    source = ioctl(igsvga_fd,IGSVGA_WRITE,&source);

	    if (source < 0)
	        printf("igsvga: Register write returned error 0x%X!\n", source);

	}

	else {
		printf("usage: igs_reg                       - dump IGS VGA registers\n");
		printf("       igs_reg x reg val [x reg val ...] - program reg x[g..c..a..s..m..t]\n");
		printf("                  all value are hex (0x..) or decimal\n");
		printf("       For example: \n");
		printf("       igs_reg g 9 0x98 s 1 0x04\n");
		exit(1);
	}

	close(igsvga_fd);

}
